diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/spectrum/model/three-gpp-channel-model.cc ns-3.47/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.46/src/spectrum/model/three-gpp-channel-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/spectrum/model/three-gpp-channel-model.cc	2026-02-16 16:08:49.824230700 -0800
@@ -2332,50 +2290,31 @@
             }
             else if (channelCondition->IsNlos())
             {
-                table3gpp->m_uLgDS =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgDS];
-                table3gpp->m_sigLgDS =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgDS];
-                table3gpp->m_uLgASD =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASD];
-                table3gpp->m_sigLgASD =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASD];
-                table3gpp->m_uLgASA =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASA];
-                table3gpp->m_sigLgASA =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASA];
-                table3gpp->m_uLgZSA =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSA];
-                table3gpp->m_sigLgZSA =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSA];
-                table3gpp->m_uLgZSD =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSD];
-                table3gpp->m_sigLgZSD =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSD];
-                table3gpp->m_uK =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uK];
-                table3gpp->m_sigK =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigK];
-                table3gpp->m_rTau =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::rTau];
-                table3gpp->m_uXpr =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uXpr];
-                table3gpp->m_sigXpr =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigXpr];
+                table3gpp->m_uLgDS = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[uLgDS];
+                table3gpp->m_sigLgDS = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[sigLgDS];
+                table3gpp->m_uLgASD = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[uLgASD];
+                table3gpp->m_sigLgASD = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[sigLgASD];
+                table3gpp->m_uLgASA = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[uLgASA];
+                table3gpp->m_sigLgASA = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[sigLgASA];
+                table3gpp->m_uLgZSA = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[uLgZSA];
+                table3gpp->m_sigLgZSA = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[sigLgZSA];
+                table3gpp->m_uLgZSD = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[uLgZSD];
+                table3gpp->m_sigLgZSD = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[sigLgZSD];
+                table3gpp->m_uK = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[uK];
+                table3gpp->m_sigK = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[sigK];
+                table3gpp->m_rTau = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[rTau];
+                table3gpp->m_uXpr = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[uXpr];
+                table3gpp->m_sigXpr = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[sigXpr];
                 table3gpp->m_numOfCluster =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::numOfCluster];
-                table3gpp->m_raysPerCluster = NTNRuralNLOS.at(freqBand).at(
-                    elevAngleQuantized)[Table3gppParams::raysPerCluster];
-                table3gpp->m_cDS =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS] * 1e-9;
-                table3gpp->m_cASD =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
-                table3gpp->m_cASA =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASA];
-                table3gpp->m_cZSA =
-                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cZSA];
-                table3gpp->m_perClusterShadowingStd = NTNRuralNLOS.at(freqBand).at(
-                    elevAngleQuantized)[Table3gppParams::perClusterShadowingStd];
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[numOfCluster];
+                table3gpp->m_raysPerCluster =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[raysPerCluster];
+                table3gpp->m_cDS = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[cDS] * 1e-9;
+                table3gpp->m_cASD = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[cASD];
+                table3gpp->m_cASA = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[cASA];
+                table3gpp->m_cZSA = NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[cZSA];
+                table3gpp->m_perClusterShadowingStd =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[perClusterShadowingStd];
 
                 if (freqBand == "S")
                 {
@@ -2420,53 +2359,151 @@
 }
 
 bool
-ThreeGppChannelModel::ChannelParamsNeedsUpdate(Ptr<const ThreeGppChannelParams> channelParams,
-                                               Ptr<const ChannelCondition> channelCondition) const
+ThreeGppChannelModel::NewChannelParamsNeeded(uint64_t channelParamsKey,
+                                             Ptr<const ChannelCondition> condition,
+                                             Ptr<const MobilityModel> aMob,
+                                             Ptr<const MobilityModel> bMob) const
 {
     NS_LOG_FUNCTION(this);
 
-    bool update = false;
-
-    // if the channel condition is different the channel has to be updated
-    if (!channelCondition->IsEqual(channelParams->m_losCondition, channelParams->m_o2iCondition))
+    if (const auto it = m_channelParamsMap.find(channelParamsKey); it == m_channelParamsMap.end())
     {
-        NS_LOG_DEBUG("Update the channel condition");
-        update = true;
+        NS_LOG_DEBUG("New channel parameters will be created for the first time for this link:"
+                     << channelParamsKey);
+        return true;
     }
-
-    // if the coherence time is over the channel has to be updated
-    if (!m_updatePeriod.IsZero() &&
-        Simulator::Now() - channelParams->m_generatedTime > m_updatePeriod)
+    else
     {
-        NS_LOG_DEBUG("Generation time " << channelParams->m_generatedTime.As(Time::NS) << " now "
-                                        << Now().As(Time::NS));
-        update = true;
+        if (!m_updatePeriod.IsZero())
+        {
+            const double endpointDisplacement =
+                ComputeEndpointDisplacement2d(aMob,
+                                              bMob,
+                                              it->second->m_lastPositionFirst,
+                                              it->second->m_lastPositionSecond);
+
+            if (endpointDisplacement > kMaxConsistencyStepMeters)
+            {
+                NS_LOG_DEBUG("New channel parameters needed because endpoint displacement > 1 m");
+                return true;
+            }
+        }
+
+        if (!condition->IsEqual(it->second->m_losCondition, it->second->m_o2iCondition))
+        {
+            NS_LOG_DEBUG("New channel parameters needed because LOS or O2I condition changed");
+            return true;
+        }
     }
+    return false;
+}
 
-    return update;
+bool
+ThreeGppChannelModel::NewChannelMatrixNeeded(const uint64_t channelMatrixKey,
+                                             Ptr<const ThreeGppChannelParams> channelParams,
+                                             Ptr<const PhasedArrayModel> aAntenna,
+                                             Ptr<const PhasedArrayModel> bAntenna) const
+{
+    NS_LOG_FUNCTION(this);
+    if (const auto itMatrix = m_channelMatrixMap.find(channelMatrixKey);
+        itMatrix == m_channelMatrixMap.end())
+    {
+        NS_LOG_DEBUG("Generate a new channel matrix. Matrix not found.");
+        // This function call is needed because of the API of PhasedArrayModel/UniformPlannarArray,
+        // which assumes that this function is called when the channel is created
+        const bool channelNeedsToBeCreated = aAntenna->IsChannelOutOfDate(bAntenna);
+        NS_ASSERT_MSG(channelNeedsToBeCreated,
+                      "This assert is to ensure that this code stays aligned with "
+                      "PhasedArrayModel/UniformPlannarArray "
+                      "API, which expects that this function is being called on the initial "
+                      "channel matrix creation.");
+        return true;
+    }
+    else
+    {
+        const Time paramsT = channelParams->m_generatedTime;
+        const Time matrixT = itMatrix->second->m_generatedTime;
+        const bool paramsNewer = paramsT > matrixT;
+        const bool antennaChanged = AntennaSetupChanged(aAntenna, bAntenna, itMatrix->second);
+
+        // channel parameters changed
+        if (paramsNewer || antennaChanged)
+        {
+            NS_LOG_DEBUG("Generate a new channel matrix: paramsNewer="
+                         << paramsNewer << " antennaChanged=" << antennaChanged << " paramsT="
+                         << paramsT.As(Time::NS) << " matrixT=" << matrixT.As(Time::NS));
+            return true;
+        }
+        return false;
+    }
 }
 
 bool
-ThreeGppChannelModel::ChannelMatrixNeedsUpdate(Ptr<const ThreeGppChannelParams> channelParams,
-                                               Ptr<const ChannelMatrix> channelMatrix)
+ThreeGppChannelModel::ChannelUpdateNeeded(Ptr<const ThreeGppChannelParams> channelParams,
+                                          Ptr<const MobilityModel> aMob,
+                                          Ptr<const MobilityModel> bMob) const
 {
-    return channelParams->m_generatedTime > channelMatrix->m_generatedTime;
+    NS_LOG_FUNCTION(this);
+    // Channel updates are disabled
+    if (m_updatePeriod.IsZero())
+    {
+        return false;
+    }
+
+    const double endpointDisplacement =
+        ComputeEndpointDisplacement2d(aMob,
+                                      bMob,
+                                      channelParams->m_lastPositionFirst,
+                                      channelParams->m_lastPositionSecond);
+
+    // No endpoint displacement -> no channel consistency update needed
+    if (endpointDisplacement < kNoDisplacementEpsMeters)
+    {
+        return false;
+    }
+
+    NS_ABORT_MSG_IF(endpointDisplacement > kMaxConsistencyStepMeters,
+                    "Endpoint displacement exceeded 1 m; channel parameters should have been "
+                    "regenerated before attempting a consistency update.");
+
+    // if the spatial consistency update period has elapsed, update the channel
+    if (Simulator::Now() - channelParams->m_generatedTime > m_updatePeriod)
+    {
+        NS_LOG_DEBUG("Updating channel generated at "
+                     << channelParams->m_generatedTime.As(Time::NS));
+        return true;
+    }
+    return false;
 }
 
 bool
 ThreeGppChannelModel::AntennaSetupChanged(Ptr<const PhasedArrayModel> aAntenna,
                                           Ptr<const PhasedArrayModel> bAntenna,
-                                          Ptr<const ChannelMatrix> channelMatrix)
+                                          Ptr<const ChannelMatrix> channelMatrix) const
 {
+    NS_LOG_FUNCTION(this);
     // This allows changing the number of antenna ports during execution,
     // which is used by nr's initial association.
-    size_t sAntNumElems = aAntenna->GetNumElems();
-    size_t uAntNumElems = bAntenna->GetNumElems();
-    size_t chanNumRows = channelMatrix->m_channel.GetNumRows();
-    size_t chanNumCols = channelMatrix->m_channel.GetNumCols();
-    return (((uAntNumElems != chanNumRows) || (sAntNumElems != chanNumCols)) &&
-            ((uAntNumElems != chanNumCols) || (sAntNumElems != chanNumRows))) ||
-           aAntenna->IsChannelOutOfDate(bAntenna);
+    const size_t sAntNumElems = aAntenna->GetNumElems();
+    const size_t uAntNumElems = bAntenna->GetNumElems();
+    const size_t chanNumRows = channelMatrix->m_channel.GetNumRows();
+    const size_t chanNumCols = channelMatrix->m_channel.GetNumCols();
+    const bool dimsMatchNormal = uAntNumElems == chanNumRows && sAntNumElems == chanNumCols;
+    const bool dimsMatchSwapped = uAntNumElems == chanNumCols && sAntNumElems == chanNumRows;
+    const bool dimsMismatch = !(dimsMatchNormal || dimsMatchSwapped);
+    const bool channelOutOfDate = aAntenna->IsChannelOutOfDate(bAntenna);
+    const bool changed = dimsMismatch || channelOutOfDate;
+
+    if (changed)
+    {
+        NS_LOG_DEBUG("AntennaSetupChanged: dimsMismatch="
+                     << dimsMismatch << " channelOutOfDate=" << channelOutOfDate
+                     << " uAntNumElems=" << uAntNumElems << " sAntNumElems=" << sAntNumElems
+                     << " chanNumRows=" << chanNumRows << " chanNumCols=" << chanNumCols
+                     << " aAntennaId=" << aAntenna->GetId() << " bAntennaId=" << bAntenna->GetId());
+    }
+
+    return changed;
 }
 
 Ptr<const MatrixBasedChannelModel::ChannelMatrix>
@@ -2478,84 +2515,64 @@
     NS_LOG_FUNCTION(this);
 
     // Compute the channel params key. The key is reciprocal, i.e., key (a, b) = key (b, a)
-    uint64_t channelParamsKey =
+    const uint64_t channelParamsKey =
         GetKey(aMob->GetObject<Node>()->GetId(), bMob->GetObject<Node>()->GetId());
-    // Compute the channel matrix key. The key is reciprocal, i.e., key (a, b) = key (b, a)
-    uint64_t channelMatrixKey = GetKey(aAntenna->GetId(), bAntenna->GetId());
-
     // retrieve the channel condition
-    Ptr<const ChannelCondition> condition =
+    const Ptr<const ChannelCondition> condition =
         m_channelConditionModel->GetChannelCondition(aMob, bMob);
-
-    // Check if the channel is present in the map and return it, otherwise
-    // generate a new channel
-    bool updateParams = false;
-    bool updateMatrix = false;
-    bool notFoundParams = false;
-    bool notFoundMatrix = false;
-    Ptr<ChannelMatrix> channelMatrix;
-    Ptr<ThreeGppChannelParams> channelParams;
-
-    if (m_channelParamsMap.find(channelParamsKey) != m_channelParamsMap.end())
-    {
-        channelParams = m_channelParamsMap[channelParamsKey];
-        // check if it has to be updated
-        updateParams = ChannelParamsNeedsUpdate(channelParams, condition);
-    }
-    else
+    // Enforce canonical ordering when selecting scenario parameters.
+    Ptr<const MobilityModel> aMobOrdered = aMob;
+    Ptr<const MobilityModel> bMobOrdered = bMob;
+    if (aMob->GetObject<Node>()->GetId() > bMob->GetObject<Node>()->GetId())
     {
-        NS_LOG_DEBUG("channel params not found");
-        notFoundParams = true;
+        std::swap(aMobOrdered, bMobOrdered);
     }
-
     // get the 3GPP parameters
-    Ptr<const ParamsTable> table3gpp = GetThreeGppTable(aMob, bMob, condition);
+    const Ptr<const ParamsTable> table3gpp = GetThreeGppTable(aMobOrdered, bMobOrdered, condition);
 
-    if (notFoundParams || updateParams)
+    if (NewChannelParamsNeeded(channelParamsKey, condition, aMob, bMob))
     {
-        // Step 4: Generate large scale parameters. All LSPS are uncorrelated.
-        // Step 5: Generate Delays.
-        // Step 6: Generate cluster powers.
-        // Step 7: Generate arrival and departure angles for both azimuth and elevation.
-        // Step 8: Coupling of rays within a cluster for both azimuth and elevation
-        // shuffle all the arrays to perform random coupling
-        // Step 9: Generate the cross polarization power ratios
-        // Step 10: Draw initial phases
-        channelParams = GenerateChannelParameters(condition, table3gpp, aMob, bMob);
-        // store or replace the channel parameters
-        m_channelParamsMap[channelParamsKey] = channelParams;
-    }
-
-    if (m_channelMatrixMap.find(channelMatrixKey) != m_channelMatrixMap.end())
-    {
-        // channel matrix present in the map
-        NS_LOG_DEBUG("channel matrix present in the map");
-        channelMatrix = m_channelMatrixMap[channelMatrixKey];
-        updateMatrix = ChannelMatrixNeedsUpdate(channelParams, channelMatrix);
-        updateMatrix |= AntennaSetupChanged(aAntenna, bAntenna, channelMatrix);
+        NS_LOG_DEBUG(
+            "Create new or regenerate the channel parameters because the condition has changed");
+        m_channelParamsMap.insert_or_assign(
+            channelParamsKey,
+            GenerateChannelParameters(condition, table3gpp, aMobOrdered, bMobOrdered));
     }
     else
     {
-        NS_LOG_DEBUG("channel matrix not found");
-        notFoundMatrix = true;
+        const auto it = m_channelParamsMap.find(channelParamsKey);
+        NS_ASSERT(it != m_channelParamsMap.end());
+        if (ChannelUpdateNeeded(it->second, aMob, bMob))
+        {
+            NS_LOG_DEBUG("Update the channel parameters using consistency procedure");
+            UpdateChannelParameters(it->second, condition, aMob, bMob);
+        }
+        else
+        {
+            NS_LOG_DEBUG("No channel params update. Using already existing channel params.");
+        }
     }
 
-    // If the channel is not present in the map or if it has to be updated
-    // generate a new realization
-    if (notFoundMatrix || updateMatrix)
-    {
-        // channel matrix not found or has to be updated, generate a new one
-        channelMatrix = GetNewChannel(channelParams, table3gpp, aMob, bMob, aAntenna, bAntenna);
-        channelMatrix->m_antennaPair =
-            std::make_pair(aAntenna->GetId(),
-                           bAntenna->GetId()); // save antenna pair, with the exact order of s and u
-                                               // antennas at the moment of the channel generation
-
-        // store or replace the channel matrix in the channel map
-        m_channelMatrixMap[channelMatrixKey] = channelMatrix;
+    // Compute the channel matrix key. The key is reciprocal, i.e., key (a, b) = key (b, a)
+    const uint64_t channelMatrixKey = GetKey(aAntenna->GetId(), bAntenna->GetId());
+    // If the channel matrix is not present in the map or if it has to be updated
+    if (NewChannelMatrixNeeded(channelMatrixKey,
+                               m_channelParamsMap.find(channelParamsKey)->second,
+                               aAntenna,
+                               bAntenna))
+    {
+        m_channelMatrixMap.insert_or_assign(
+            channelMatrixKey,
+            GetNewChannel(m_channelParamsMap.find(channelParamsKey)->second,
+                          table3gpp,
+                          aMob,
+                          bMob,
+                          aAntenna,
+                          bAntenna));
     }
 
-    return channelMatrix;
+    NS_ASSERT(m_channelMatrixMap.contains(channelMatrixKey));
+    return m_channelMatrixMap.find(channelMatrixKey)->second;
 }
 
 Ptr<const MatrixBasedChannelModel::ChannelParams>
